# General game stuff to make the map work

# Powdered snow teleport
execute as @a[x=7,y=99,z=3,distance=..1] at @s run playsound minecraft:entity.enderman.teleport master @s
execute as @a[x=7,y=99,z=3,distance=..1] run tp @s 5.53 101.00 0.73 -757.75 23.85
execute as @e[type=!player,x=7,y=99,z=3,distance=..3] run tp @s 5.53 101.00 0.73 -757.75 23.85

# Levitation button
execute if block -2 99 9 minecraft:spruce_button[powered=true] positioned -4 99 8 as @p at @s if block ~ ~-8.2 ~ calcite run effect give @s levitation 1 3 true
execute as @a at @s unless block ~ ~-8.0 ~ calcite run effect clear @s levitation
execute if block -2 99 9 minecraft:spruce_button[powered=true] run scoreboard players add global buttonTimer 1
execute if score global buttonTimer matches 20 run setblock -2 99 9 spruce_button[facing=west]
execute if score global buttonTimer matches 20 run scoreboard players set global buttonTimer 0
kill @e[type=arrow,nbt={inGround:1b}]

# Minecart placeability
execute as @a if score @s minecart matches 1 run clear @s minecart
execute as @a if score @s minecart matches 1 run give @s minecart{CanPlaceOn:["minecraft:rail"]}
execute as @a if score @s minecart matches 1 run scoreboard players reset @s minecart

# Upgraded pickaxe
execute as @a if score @s upgraded_pickaxe matches 1 run clear @s diamond_pickaxe
execute as @a if score @s upgraded_pickaxe matches 1 run give @s diamond_pickaxe{CanDestroy:["minecraft:stone_bricks"],HideFlags:2,Unbreakable:1b,Enchantments:[{}]} 1
execute as @a if score @s upgraded_pickaxe matches 1 run kill @e[tag=combine]
execute as @a if score @s upgraded_pickaxe matches 1 run scoreboard players set @s upgraded_pickaxe 2
execute as @a[nbt={Inventory:[{id:"minecraft:diamond_pickaxe"}]}] unless entity @a[scores={upgraded_pickaxe=1..2}] run scoreboard players set @s upgraded_pickaxe 1

# Item frame invulnerability
execute as @e[type=item_frame,nbt=!{Item:{}}] run data merge entity @s {Invulnerable:1b}
execute as @e[type=item_frame,nbt={Item:{}},tag=!map] run data merge entity @s {Invulnerable:0b}
execute as @e[type=glow_item_frame,nbt=!{Item:{}}] run data merge entity @s {Invulnerable:1b}
execute as @e[type=glow_item_frame,nbt={Item:{}}] run data merge entity @s {Invulnerable:0b}

# Tp villager (slime ball detection)
execute unless entity @a[scores={slimed=1..}] run tp @e[type=villager,tag=slimeball] 0 99 -3

# Slime ball conversion
execute as @a[scores={slimeball=1..},nbt={SelectedItem:{id:"minecraft:slime_ball"}}] at @s run function mj:methods/slime
execute unless entity @a[nbt={SelectedItem:{id:"minecraft:slime_ball"}}] unless entity @a[nbt={SelectedItem:{id:"minecraft:chest"}}] run scoreboard players reset @a slimeball

# Rails
execute as @a[x=-4,y=104,z=-11,distance=..1] as @e[type=minecart,x=-4,y=104,z=-11,distance=..1] run setblock -4 104 -11 air
execute as @a[x=-4,y=104,z=-11,distance=..1] as @e[type=minecart,x=-4,y=104,z=-11,distance=..1] run data merge entity @s {Invulnerable:1b}

# Water bucket replace
execute as @a[nbt={Inventory:[{id:"minecraft:bucket"}]}] unless entity @s[nbt={Inventory:[{id:"minecraft:bucket",tag:{CanPlaceOn:["minecraft:powder_snow","minecraft:water"],display:{Lore:['{"text":" "}','{"text":"Can be placed on:","color":"gray","italic":false}','{"text":"Water","color":"dark_gray","italic":false}']},HideFlags:16}}]}] run function mj:methods/replace_bucket
execute as @a[nbt={Inventory:[{id:"minecraft:water_bucket"}]}] unless entity @s[nbt={Inventory:[{id:"minecraft:water_bucket",tag:{CanPlaceOn:["minecraft:smooth_quartz"],CanDestroy:["minecraft:iron_trapdoor"]}}]}] run function mj:methods/replace_water_bucket

# Crafting puzzle
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:12b}]}] run give @s oak_planks 2
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:12b}]}] run clear @s stick 4
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:16b}]}] run give @s oak_planks 4
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:16b}]}] run clear @s stick 8
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:20b}]}] run give @s oak_planks 6
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:20b}]}] run clear @s stick 12
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:24b}]}] run give @s oak_planks 8
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:24b}]}] run clear @s stick 16
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:28b}]}] run give @s oak_planks 10
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:28b}]}] run clear @s stick 20
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:32b}]}] run give @s oak_planks 12
execute as @a[nbt={Inventory:[{id:"minecraft:stick",Count:32b}]}] run clear @s stick 24

execute as @a if score @s sticks >= 8 sticks run recipe take @a stick

execute as @a[nbt={Inventory:[{id:"minecraft:crafting_table",Count:2b}]}] run give @s oak_planks 4
execute as @a[nbt={Inventory:[{id:"minecraft:crafting_table",Count:3b}]}] run give @s oak_planks 8
execute as @a[nbt={Inventory:[{id:"minecraft:crafting_table",Count:4b}]}] run give @s oak_planks 12

execute as @a if score @s crafting_table >= 1 crafting_table run recipe take @a crafting_table
execute as @a if score @s crafting_table >= 1 crafting_table run clear @s crafting_table
execute as @a if score @s crafting_table >= 1 crafting_table run give @s crafting_table{CanPlaceOn:["sea_lantern"]}
execute as @a if score @s crafting_table >= 1 crafting_table run scoreboard players reset @s crafting_table

execute as @a if score @s ladder matches 3 run clear @s ladder
execute as @a if score @s ladder matches 3 run give @s ladder{CanPlaceOn:["oak_wood"]} 3
execute as @a if score @s ladder matches 3 run scoreboard players reset @s ladder

execute as @a if score @s chest matches 1 run clear @s chest
execute as @a if score @s chest matches 1 run give @s chest{display:{Lore:['{"text":""}','[{"text":"Can be placed on:","color":"gray","italic":false}]','{"text":"Minecart","color":"dark_gray","italic":false}']}}
execute as @a if score @s chest matches 1 run scoreboard players reset @s chest

# Minecart conversion
execute as @a[scores={slimeball=1..},nbt={SelectedItem:{id:"minecraft:chest"}}] at @s run function mj:methods/minecart

# Powdered fuel
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} unless score global furnace matches 1 run function mj:methods/furnace

execute if block -15 102 -2 blast_furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} positioned -15 102 -2 run playsound entity.villager.no master @p
execute if block -15 102 -2 blast_furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} positioned -15 102 -2 run give @p charcoal{display:{Name:'{"text":"Powdered Fuel","color":"dark_purple","italic":false}',Lore:['{"text":" "}','{"text":"Can Smelt:","color":"gray","italic":false}','{"text":"Rock-hard substances","color":"dark_gray","italic":false}']}}
execute if block -15 102 -2 blast_furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} run item replace block -15 102 -2 container.1 with air
execute if block -15 101 -1 smoker{Items:[{Slot:1b,id:"minecraft:charcoal"}]} positioned -15 101 -1 run playsound entity.villager.no master @p
execute if block -15 101 -1 smoker{Items:[{Slot:1b,id:"minecraft:charcoal"}]} positioned -15 101 -1 run give @p charcoal{display:{Name:'{"text":"Powdered Fuel","color":"dark_purple","italic":false}',Lore:['{"text":" "}','{"text":"Can Smelt:","color":"gray","italic":false}','{"text":"Rock-hard substances","color":"dark_gray","italic":false}']}}
execute if block -15 101 -1 smoker{Items:[{Slot:1b,id:"minecraft:charcoal"}]} run item replace block -15 101 -1 container.1 with air
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:coal"}]} positioned 3 101 5 run playsound entity.villager.no master @p
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:coal"}]} positioned 3 101 5 run give @p coal
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:coal"}]} run item replace block 3 101 5 container.1 with air

execute if score global furnace matches 1 run clear @a charcoal

execute if block 3 101 5 furnace{Items:[{Slot:2b,id:"minecraft:iron_horse_armor"}]} run item replace block 3 101 5 container.2 with black_concrete_powder{CanPlaceOn:["chiseled_deepslate"]}
execute as @a[nbt={Inventory:[{id:"minecraft:iron_horse_armor"}]}] run give @s black_concrete_powder{CanPlaceOn:["chiseled_deepslate"]}
execute as @a[nbt={Inventory:[{id:"minecraft:iron_horse_armor"}]}] run clear @s iron_horse_armor

execute if score global furnace matches 1 unless block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} run item replace block -5 96 -1 container.1 with air
execute if score global furnace matches 1 unless block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} run data modify block -5 96 -1 Items[{Slot:0b}] set from block 3 101 5 Items[{Slot:1b}]
execute if score global furnace matches 1 unless block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} positioned 3 101 5 run loot give @p mine -5 96 -1 air{drop_contents:1b}
execute if score global furnace matches 1 unless block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:charcoal"}]} run item replace block 3 101 5 container.1 with charcoal{Enchantments:[{}],display:{Name:'{"text":"Powdered Fuel","color":"green","italic":false}',Lore:['{"text":" "}','{"text":"Can Smelt:","color":"gray","italic":false}','{"text":"Rock-hard substances","color":"dark_gray","italic":false}']}}

# Staircase puzzle
execute as @e[type=item,nbt={Item:{id:"minecraft:brown_carpet"}}] run data merge entity @s {Item:{id:"brown_carpet",tag:{CanPlaceOn:["polished_deepslate"]}}}
execute as @e[type=item,nbt={Item:{id:"minecraft:end_rod"}}] run data merge entity @s {Item:{id:"end_rod",tag:{CanPlaceOn:["polished_deepslate"]}}}
execute as @e[type=item,nbt={Item:{id:"minecraft:enchanting_table"}}] run data merge entity @s {Item:{id:"enchanting_table",tag:{CanPlaceOn:["polished_deepslate"]}}}
execute as @e[type=item,nbt={Item:{id:"minecraft:conduit"}}] run data merge entity @s {Item:{id:"conduit",tag:{CanPlaceOn:["polished_deepslate"]}}}

# Gravel Ax
execute as @a if score @s axe matches 1 run clear @s stone_axe
execute as @a if score @s axe matches 1 run give @s stone_axe{CanDestroy:["minecraft:oak_log","minecraft:jungle_leaves"],HideFlags:2,Unbreakable:1b}
execute as @a if score @s axe matches 1 run scoreboard players reset @s axe

# Soft-lock prevention
execute if block -15 102 -2 blast_furnace{Items:[{Slot:0b,id:"minecraft:golden_pickaxe"}]} positioned -15 102 -2 run playsound entity.villager.no master @p
execute if block -15 102 -2 blast_furnace{Items:[{Slot:0b,id:"minecraft:golden_pickaxe"}]} positioned -15 102 -2 run give @p golden_pickaxe{CanDestroy:["minecraft:black_concrete","minecraft:chiseled_quartz_block"],HideFlags:2,Unbreakable:1b,Enchantments:[{}]}
execute if block -15 102 -2 blast_furnace{Items:[{Slot:0b,id:"minecraft:golden_pickaxe"}]} run item replace block -15 102 -2 container.0 with air
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:bow"}]} positioned 3 101 5 run playsound entity.villager.no master @p
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:bow"}]} positioned 3 101 5 run give @p bow{Unbreakable:1b,Enchantments:[{id:"minecraft:infinity",lvl:1s}]}
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:bow"}]} run item replace block 3 101 5 container.1 with air
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:stick"}]} positioned 3 101 5 run playsound entity.villager.no master @p
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:stick"}]} positioned 3 101 5 run give @p stick
execute if block 3 101 5 furnace{Items:[{Slot:1b,id:"minecraft:stick"}]} run item replace block 3 101 5 container.1 with air
execute if block 3 101 5 furnace{Items:[{Slot:0b,id:"minecraft:golden_pickaxe"}]} positioned 3 101 5 run playsound entity.villager.no master @p
execute if block 3 101 5 furnace{Items:[{Slot:0b,id:"minecraft:golden_pickaxe"}]} positioned 3 101 5 run give @p golden_pickaxe{CanDestroy:["minecraft:black_concrete","minecraft:chiseled_quartz_block"],HideFlags:2,Unbreakable:1b,Enchantments:[{}]}
execute if block 3 101 5 furnace{Items:[{Slot:0b,id:"minecraft:golden_pickaxe"}]} run item replace block 3 101 5 container.0 with air

# Haste when holding bucket
effect give @a[nbt={SelectedItem:{id:"minecraft:water_bucket"}}] haste 1 50 true
effect clear @a[nbt=!{SelectedItem:{id:"minecraft:water_bucket"}}] haste

# Paintings
execute as @e[type=painting] run data merge entity @s {Invulnerable:1b}

# Plus icon
execute unless block -1 106 10 brown_shulker_box{Items:[{Slot:13b,id:"minecraft:green_stained_glass_pane"}]} run item replace block -4 96 -1 container.13 with air
execute unless block -1 106 10 brown_shulker_box{Items:[{Slot:13b,id:"minecraft:green_stained_glass_pane"}]} run data modify block -4 96 -1 Items[{Slot:0b}] set from block -1 106 10 Items[{Slot:13b}]
execute unless block -1 106 10 brown_shulker_box{Items:[{Slot:13b,id:"minecraft:green_stained_glass_pane"}]} positioned -1 106 10 run loot give @p mine -4 96 -1 air{drop_contents:1b}
execute unless block -1 106 10 brown_shulker_box{Items:[{Slot:13b,id:"minecraft:green_stained_glass_pane"}]} run item replace block -1 106 10 container.13 with green_stained_glass_pane{display:{Name:'{"text":""}'}}
clear @a green_stained_glass_pane

# Super pickaxe
execute at @e[type=item,nbt={Item:{id:"minecraft:diamond_pickaxe"}}] if entity @e[distance=..1,type=item,nbt={Item:{id:"minecraft:netherite_pickaxe"}}] if entity @e[distance=..1,type=item,nbt={Item:{id:"minecraft:golden_pickaxe"}}] run function mj:methods/super_pickaxe

# Loom -> dropper
execute as @e[type=item,nbt={Item:{id:"minecraft:loom"}}] run data merge entity @s {Item:{id:"loom",tag:{CanPlaceOn:["stripped_birch_log"]}}}
execute if block 7 109 -24 loom run setblock 7 109 -24 dropper[facing=south]{Items:[{Slot:4b,id:"minecraft:pumpkin_seeds",Count:1b,tag:{display:{Name:'{"text":"Recoloring Recipe","color":"yellow","italic":false}'}}}],CustomName:'{"text":"Recolor"}'} replace

# Recolor puzzle
execute as @a if score @s boots matches 1 run function mj:methods/replace_boots
execute if blocks 7 107 -24 7 107 -24 7 109 -24 all run function mj:methods/complete_boots

# Game-defying boots
execute as @a[nbt={Inventory:[{id:"minecraft:leather_boots",Slot:100b,tag:{Special:1b}}]}] run tag @s add jump
execute unless entity @a[nbt={Inventory:[{id:"minecraft:leather_boots",Slot:100b,tag:{Special:1b}}]}] run tag @a remove jump

# Fire charge replace
execute as @a if score @s fire_charge matches 1 run clear @a fire_charge
execute as @a if score @s fire_charge matches 1 run give @s fire_charge{CanPlaceOn:["netherrack"]}
execute as @a if score @s fire_charge matches 1 run scoreboard players reset @s fire_charge

# Rock-hard substances
execute as @e[type=item,nbt={Item:{id:"minecraft:black_concrete"}}] run data merge entity @s {Item:{id:"black_concrete",tag:{display:{Lore:['{"text":"Made of rocks.","color":"dark_gray","italic":false}']}}}}
execute as @e[type=item,nbt={Item:{id:"minecraft:stone_bricks"}}] run data merge entity @s {Item:{id:"stone_bricks",tag:{display:{Lore:['{"text":"Made of rocks.","color":"dark_gray","italic":false}']}}}}

# Barrier slime block prevention
execute as @a at @s if block ~ ~-12.1 ~ minecraft:amethyst_block run setblock 0 109 -3 minecraft:barrier

# Firework star soft-lock
execute as @a[nbt={Inventory:[{id:"minecraft:firework_star"}]}] run function mj:methods/reset_firework_star